Index: LMDZ4/trunk/libf/dyn3dpar/gcm.F
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/gcm.F	(revision 1122)
+++ LMDZ4/trunk/libf/dyn3dpar/gcm.F	(revision 1146)
@@ -9,14 +9,22 @@
       USE IOIPSL
 #endif
+
       USE mod_const_mpi, ONLY: init_const_mpi
       USE parallel
       USE mod_phys_lmdz_para, ONLY : klon_mpi_para_nb
-      USE mod_grid_phy_lmdz
-      USE mod_phys_lmdz_omp_data, ONLY: klon_omp
-      USE dimphy
+      USE infotrac
       USE mod_interface_dyn_phys
-      USE comgeomphy
       USE mod_hallo
       USE Bands
+
+      USE filtreg_mod
+
+! Ehouarn: for now these only apply to Earth:
+#ifdef CPP_EARTH
+      USE mod_grid_phy_lmdz
+      USE mod_phys_lmdz_omp_data, ONLY: klon_omp 
+      USE dimphy
+      USE comgeomphy
+#endif
       IMPLICIT NONE
 
@@ -65,5 +73,4 @@
 #include "iniprint.h"
 #include "tracstoke.h"
-#include "advtrac.h"
 
       INTEGER         longcles
@@ -81,5 +88,5 @@
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL teta(ip1jmp1,llm)                 ! temperature potentielle 
-      REAL q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL, ALLOCATABLE, DIMENSION(:,:,:) :: q ! champs advectes
       REAL ps(ip1jmp1)                       ! pression  au sol
 c      REAL p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
@@ -136,5 +143,5 @@
 c    variables pour l'initialisation de la physique :
 c    ------------------------------------------------
-      INTEGER ngridmx,nq
+      INTEGER ngridmx
       PARAMETER( ngridmx = 2+(jjm-1)*iim - 1/jjm   )
       REAL zcufi(ngridmx),zcvfi(ngridmx)
@@ -158,34 +165,4 @@
 
 
-c initialisation Anne
-      hadv_flg(:) = 0.
-      vadv_flg(:) = 0.
-      conv_flg(:) = 0.
-      pbl_flg(:)  = 0. 
-      tracnam(:)  = '        ' 
-      nprath = 1
-      nbtrac = 0
-      mmt_adj(:,:,:,:) = 1
-
-
-c--------------------------------------------------------------------------
-c   Iflag_phys controle l'appel a la physique :
-c   -------------------------------------------
-c      0 : pas de physique
-c      1 : Normale (appel a phylmd, phymars ...)
-c      2 : rappel Newtonien pour la temperature + friction au sol
-      iflag_phys=1
-
-c--------------------------------------------------------------------------
-c   Lecture de l'etat initial :
-c   ---------------------------
-c     T : on lit start.nc
-c     F : le modele s'autoinitialise avec un cas academique (iniacademic)
-#ifdef CPP_IOIPSL
-      read_start=.true.
-#else
-      read_start=.false.
-#endif
-
 c-----------------------------------------------------------------------
 c   Choix du calendrier
@@ -203,9 +180,10 @@
 c  ---------------------------------------
 c
-#ifdef CPP_IOIPSL
+! Ehouarn: dump possibility of using defrun
+!#ifdef CPP_IOIPSL
       CALL conf_gcm( 99, .TRUE. , clesphy0 )
-#else
-      CALL defrun( 99, .TRUE. , clesphy0 )
-#endif
+!#else
+!      CALL defrun( 99, .TRUE. , clesphy0 )
+!#endif
 c
 c
@@ -217,5 +195,10 @@
       call init_parallel
       call Read_Distrib
-      CALL Init_Phys_lmdz(iim,jjp1,llm,nqmx-2,mpi_size,distrib_phys)
+! Ehouarn : temporarily (?) keep this only for Earth
+      if (planet_type.eq."earth") then
+#ifdef CPP_EARTH
+        CALL Init_Phys_lmdz(iim,jjp1,llm,mpi_size,distrib_phys)
+#endif
+      endif ! of if (planet_type.eq."earth")
       CALL set_bands
       CALL Init_interface_dyn_phys
@@ -229,12 +212,17 @@
 c$OMP END PARALLEL
 
+! Ehouarn : temporarily (?) keep this only for Earth
+      if (planet_type.eq."earth") then
+#ifdef CPP_EARTH
 c$OMP PARALLEL
       call InitComgeomphy
 c$OMP END PARALLEL 
+#endif
+      endif ! of if (planet_type.eq."earth")
 
       IF (config_inca /= 'none') THEN
 #ifdef INCA
          call init_const_lmdz(
-     $        nbtrac,anneeref,dayref,
+     $        nbtr,anneeref,dayref,
      $        iphysiq,day_step,nday)
 
@@ -248,9 +236,11 @@
 c   Initialisation des traceurs
 c   ---------------------------
-c  Choix du schema pour l'advection
-c  dans fichier trac.def ou via INCA
-
-       call iniadvtrac(nq)
-c
+c  Choix du nombre de traceurs et du schema pour l'advection
+c  dans fichier traceur.def, par default ou via INCA
+      call infotrac_init
+
+c Allocation de la tableau q : champs advectes   
+      ALLOCATE(q(ip1jmp1,llm,nqtot))
+
 c-----------------------------------------------------------------------
 c   Lecture de l'etat initial :
@@ -259,7 +249,17 @@
 c  lecture du fichier start.nc
       if (read_start) then
-#ifdef CPP_IOIPSL
-         CALL dynetat0("start.nc",nqmx,vcov,ucov,
+      ! we still need to run iniacademic to initialize some
+      ! constants & fields, if we run the 'newtonian' case:
+        if (iflag_phys.eq.2) then
+          CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
+        endif
+!#ifdef CPP_IOIPSL
+        if (planet_type.eq."earth") then
+#ifdef CPP_EARTH
+! Load an Earth-format start file
+         CALL dynetat0("start.nc",vcov,ucov,
      .              teta,q,masse,ps,phis, time_0)
+#endif
+        endif ! of if (planet_type.eq."earth")
 c       write(73,*) 'ucov',ucov
 c       write(74,*) 'vcov',vcov
@@ -268,14 +268,12 @@
 c       write(77,*) 'q',q
 
-#endif
-      endif
+      endif ! of if (read_start)
 
 c le cas echeant, creation d un etat initial
       IF (prt_level > 9) WRITE(lunout,*)
-     .                 'AVANT iniacademic AVANT AVANT AVANT AVANT'
+     .              'GCM: AVANT iniacademic AVANT AVANT AVANT AVANT'
       if (.not.read_start) then
-         CALL iniacademic(nqmx,vcov,ucov,teta,q,masse,ps,phis,time_0)
+         CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
       endif
-
 
 c-----------------------------------------------------------------------
@@ -359,5 +357,4 @@
 c   Initialisation de la physique :
 c   -------------------------------
-#ifdef CPP_PHYS
       IF (call_iniphys.and.iflag_phys.eq.1) THEN
          latfi(1)=rlatu(1)
@@ -380,13 +377,14 @@
 
          WRITE(lunout,*)
-     .           'WARNING!!! vitesse verticale nulle dans la physique'
-
+     .       'GCM: WARNING!!! vitesse verticale nulle dans la physique'
+! Earth:
+         if (planet_type.eq."earth") then
+#ifdef CPP_EARTH
          CALL iniphysiq(ngridmx,llm,daysec,day_ini,dtphys ,
      ,                latfi,lonfi,airefi,zcufi,zcvfi,rad,g,r,cpp     )
-
+#endif
+         endif ! of if (planet_type.eq."earth")
          call_iniphys=.false.
-
-      ENDIF
-#endif
+      ENDIF ! of IF (call_iniphys.and.(iflag_phys.eq.1))
 
 
@@ -404,4 +402,16 @@
 
 c-----------------------------------------------------------------------
+c   Initialisation des dimensions d'INCA :
+c   --------------------------------------
+      IF (config_inca /= 'none') THEN
+!$OMP PARALLEL
+#ifdef INCA
+         CALL init_inca_dim(klon_omp,llm,iim,jjm,
+     $        rlonu,rlatu,rlonv,rlatv)
+#endif
+!$OMP END PARALLEL
+      END IF
+
+c-----------------------------------------------------------------------
 c   Initialisation des I/O :
 c   ------------------------
@@ -410,10 +420,16 @@
       day_end = day_ini + nday
       WRITE(lunout,300)day_ini,day_end
+ 300  FORMAT('1'/,15x,'run du jour',i7,2x,'au jour',i7//)
+
+!#ifdef CPP_IOIPSL
+      if (planet_type.eq."earth") then
+#ifdef CPP_EARTH
+      CALL dynredem0_p("restart.nc", day_end, phis)
+#endif
+      endif
+
+      ecripar = .TRUE.
 
 #ifdef CPP_IOIPSL
-      CALL dynredem0_p("restart.nc", day_end, phis, nqmx)
-
-      ecripar = .TRUE.
-
       if ( 1.eq.1) then
       time_step = zdtvr
@@ -421,11 +437,12 @@
       t_wrt = iecri * daysec
       CALL inithist_p(dynhist_file,day_ref,annee_ref,time_step,
-     .              t_ops, t_wrt, nqmx, histid, histvid)
-
-      t_ops = iperiod * time_step
-      t_wrt = periodav * daysec
-      CALL initdynav_p(dynhistave_file,day_ref,annee_ref,time_step,
-     .              t_ops, t_wrt, nqmx, histaveid)
-
+     .              t_ops, t_wrt, histid, histvid)
+
+      IF (ok_dynzon) THEN 
+         t_ops = iperiod * time_step
+         t_wrt = periodav * daysec
+         CALL initdynav_p(dynhistave_file,day_ref,annee_ref,time_step,
+     .        t_ops, t_wrt, histaveid)
+      END IF
       dtav = iperiod*dtvr/daysec
       endif
@@ -433,4 +450,5 @@
 
 #endif
+! #endif of #ifdef CPP_IOIPSL
 
 c  Choix des frequences de stokage pour le offline
@@ -453,11 +471,9 @@
 
 c$OMP PARALLEL DEFAULT(SHARED) COPYIN(/temps/,/logic/)
-      CALL leapfrog_p(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0,
+      CALL leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
      .              time_0)
 c$OMP END PARALLEL
 
 
- 300  FORMAT('1'/,15x,'run du pas',i7,2x,'au pas',i7,2x,
-     . 'c''est a dire du jour',i7,3x,'au jour',i7//)
       END
 
Index: LMDZ4/trunk/libf/dyn3dpar/groupeun_p.F
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/groupeun_p.F	(revision 1122)
+++ LMDZ4/trunk/libf/dyn3dpar/groupeun_p.F	(revision 1146)
@@ -1,5 +1,5 @@
-      subroutine groupeun_p(jjmax,llmax,jjb,jje,q)
+      SUBROUTINE groupeun_p(jjmax,llmax,jjb,jje,q)
       USE parallel
-      implicit none
+      IMPLICIT NONE
 
 #include "dimensions.h"
@@ -8,70 +8,155 @@
 #include "comgeom2.h"
 
-      integer jjmax,llmax,jjb,jje
-      real q(iip1,jjmax,llmax)
+      INTEGER jjmax,llmax,jjb,jje
+      REAL q(iip1,jjmax,llmax)
 
-      integer ngroup
-      parameter (ngroup=3)
+      INTEGER ngroup
+      PARAMETER (ngroup=3)
 
-      real airen,airecn,qn
-      real aires,airecs,qs
+      REAL airecn,qn
+      REAL airecs,qs
 
-      integer i,j,l,ig,j1,j2,i0,jd
+      INTEGER i,j,l,ig,j1,j2,i0,jd
 
-Champs 3D
+c--------------------------------------------------------------------c 
+c Strategie d'optimisation                                           c
+c stocker les valeurs systematiquement recalculees                   c
+c et identiques d'un pas de temps sur l'autre. Il s'agit des         c
+c aires des cellules qui sont sommees. S'il n'y a pas de changement  c
+c de grille au cours de la simulation tout devrait bien se passer.   c
+c Autre optimisation : determination des bornes entre lesquelles "j" c
+c varie, au lieu de faire un test à chaque fois...
+c--------------------------------------------------------------------c 
+
+      INTEGER j_start, j_finish
+
+      REAL, SAVE :: airen_tab(iip1,jjp1,0:1)
+      REAL, SAVE :: aires_tab(iip1,jjp1,0:1)
+!$OMP THREADPRIVATE(airen_tab, aires_tab)
+
+      LOGICAL, SAVE :: first = .TRUE.
+!$OMP THREADPRIVATE(first)
+
+      IF (first) THEN
+         CALL INIT_GROUPEUN_P(airen_tab, aires_tab)
+         first = .FALSE.
+      ENDIF
+
+c Champs 3D
       jd=jjp1-jjmax
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
-      do l=1,llm
-      j1=1+jd
-      j2=2
-      do ig=1,ngroup
-         do j=j1-jd,j2-jd
-c           print*,'groupe ',ig,'  j= ',j,2**(ngroup-ig+1),'pts groupes'
-            if ( j >= jjb .AND. j <= jje) THEN
-             
-              do i0=1,iim,2**(ngroup-ig+1)
-                 
-                 airen=0.
-                 airecn=0.
-                 qn=0.
-                 
-                 do i=i0,i0+2**(ngroup-ig+1)-1
-                    airen=airen+aire(i,j)
-                    qn=qn+q(i,j,l)
-                 enddo
-                 airecn=0.
-                 do i=i0,i0+2**(ngroup-ig+1)-1
-                   q(i,j,l)=qn*aire(i,j)/airen
-                 enddo
-              enddo
-              q(iip1,j,l)=q(1,j,l)
-              
-            endif
+      DO l=1,llm
+         j1=1+jd
+         j2=2
+         DO ig=1,ngroup
+
+c     Concerne le pole nord
+            j_start  = MAX(jjb, j1-jd)
+            j_finish = MIN(jje, j2-jd)
+            DO j=j_start, j_finish
+               DO i0=1,iim,2**(ngroup-ig+1)
+                  qn=0.
+                  DO i=i0,i0+2**(ngroup-ig+1)-1
+                     qn=qn+q(i,j,l)
+                  ENDDO
+                  DO i=i0,i0+2**(ngroup-ig+1)-1
+                     q(i,j,l)=qn*airen_tab(i,j,jd)
+                  ENDDO
+               ENDDO
+               q(iip1,j,l)=q(1,j,l)
+            ENDDO
+        
+!c     Concerne le pole sud
+            j_start  = MAX(1+jjp1-jje-jd, j1-jd)
+            j_finish = MIN(1+jjp1-jjb-jd, j2-jd)
+            DO j=j_start, j_finish
+               DO i0=1,iim,2**(ngroup-ig+1)
+                  qs=0.
+                  DO i=i0,i0+2**(ngroup-ig+1)-1
+                     qs=qs+q(i,jjp1-j+1-jd,l)
+                  ENDDO
+                  DO i=i0,i0+2**(ngroup-ig+1)-1
+                     q(i,jjp1-j+1-jd,l)=qs*aires_tab(i,jjp1-j+1,jd)
+                  ENDDO
+               ENDDO
+               q(iip1,jjp1-j+1-jd,l)=q(1,jjp1-j+1-jd,l)
+            ENDDO
+        
+            j1=j2+1
+            j2=j2+2**ig
+         ENDDO
+      ENDDO
+!$OMP END DO NOWAIT
+
+      RETURN
+      END
+
+
+
+      SUBROUTINE INIT_GROUPEUN_P(airen_tab, aires_tab)
+
+      USE parallel
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "paramet.h"
+#include "comconst.h"
+#include "comgeom2.h"
+
+      INTEGER ngroup
+      PARAMETER (ngroup=3)
+
+      REAL airen,airecn
+      REAL aires,airecs
+
+      INTEGER i,j,l,ig,j1,j2,i0,jd
+
+      INTEGER j_start, j_finish
+
+      REAL :: airen_tab(iip1,jjp1,0:1)
+      REAL :: aires_tab(iip1,jjp1,0:1)
+
+      DO jd=0, 1
+         j1=1+jd
+         j2=2
+         DO ig=1,ngroup
             
-            if ( jjp1-j+1-jd >= jjb .AND. jjp1-j+1-jd <= jje) THEN
-             
-              do i0=1,iim,2**(ngroup-ig+1)
-                 aires=0.
-                 airecs=0.
-                 qs=0.
-                 do i=i0,i0+2**(ngroup-ig+1)-1
-                    aires=aires+aire(i,jjp1-j+1)
-                    qs=qs+q(i,jjp1-j+1-jd,l)
-                 enddo
-                 airecs=0.
-                 do i=i0,i0+2**(ngroup-ig+1)-1
-                   q(i,jjp1-j+1-jd,l)=qs*aire(i,jjp1-j+1)/aires
-                 enddo
-              enddo
-              q(iip1,jjp1-j+1-jd,l)=q(1,jjp1-j+1-jd,l)
-           
-            endif
-         enddo
-             
-           j1=j2+1
-           j2=j2+2**ig
-      enddo
-      enddo
-c$OMP END DO NOWAIT
-      return
-      end
+!     c     Concerne le pole nord
+            j_start = j1-jd
+            j_finish = j2-jd
+            DO j=j_start, j_finish
+               DO i0=1,iim,2**(ngroup-ig+1)
+                  airen=0.
+                  DO i=i0,i0+2**(ngroup-ig+1)-1
+                     airen = airen+aire(i,j)
+                  ENDDO
+                  DO i=i0,i0+2**(ngroup-ig+1)-1
+                     airen_tab(i,j,jd) = 
+     &                    aire(i,j) / airen
+                  ENDDO
+               ENDDO
+            ENDDO
+            
+!     c     Concerne le pole sud
+            j_start = j1-jd
+            j_finish = j2-jd
+            DO j=j_start, j_finish
+               DO i0=1,iim,2**(ngroup-ig+1)
+                  aires=0.
+                  DO i=i0,i0+2**(ngroup-ig+1)-1
+                     aires=aires+aire(i,jjp1-j+1)
+                  ENDDO
+                  DO i=i0,i0+2**(ngroup-ig+1)-1
+                     aires_tab(i,jjp1-j+1,jd) = 
+     &                    aire(i,jjp1-j+1) / aires
+                  ENDDO
+               ENDDO
+            ENDDO
+            
+            j1=j2+1
+            j2=j2+2**ig
+         ENDDO
+      ENDDO
+      
+      RETURN
+      END
Index: LMDZ4/trunk/libf/dyn3dpar/guide_p.F
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/guide_p.F	(revision 1122)
+++ LMDZ4/trunk/libf/dyn3dpar/guide_p.F	(revision 1146)
@@ -4,4 +4,5 @@
       subroutine guide_pp(itau,ucov,vcov,teta,q,masse,ps)
       USE parallel
+      use netcdf
 
       IMPLICIT NONE
@@ -229,21 +230,26 @@
          IF (mpi_rank==0) THEN
           if (guide_modele) then
-            if (ncidpl.eq.-99) ncidpl=NCOPN('apbp.nc',NCNOWRIT,rcod)
-          else	
-           if (guide_u) then
-            if (ncidpl.eq.-99) ncidpl=NCOPN('u.nc',NCNOWRIT,rcod)
-          endif
-c
-          if (guide_v) then
-            if (ncidpl.eq.-99) ncidpl=NCOPN('v.nc',NCNOWRIT,rcod)
-          endif
-c
-          if (guide_T) then
-            if (ncidpl.eq.-99) ncidpl=NCOPN('T.nc',NCNOWRIT,rcod)
-          endif
-c
-          if (guide_Q) then
-            if (ncidpl.eq.-99) ncidpl=NCOPN('hur.nc',NCNOWRIT,rcod)
-          endif
+             if (ncidpl.eq.-99) rcod=nf90_open('apbp.nc',Nf90_NOWRITe,
+     $            ncidpl)
+          else
+             if (guide_u) then
+                if (ncidpl.eq.-99) rcod=nf90_open('u.nc',Nf90_NOWRITe,
+     $               ncidpl)
+             endif
+c
+             if (guide_v) then
+                if (ncidpl.eq.-99) rcod=nf90_open('v.nc',nf90_nowrite,
+     $               ncidpl)
+             endif
+c
+             if (guide_T) then
+                if (ncidpl.eq.-99) rcod=nf90_open('T.nc',nf90_nowrite,
+     $               ncidpl)
+             endif
+c
+             if (guide_Q) then
+                if (ncidpl.eq.-99) rcod=nf90_open('hur.nc',nf90_nowrite,
+     $               ncidpl)
+             endif
 c
           endif  !guide_modele
@@ -256,5 +262,5 @@
           status=NF_INQ_DIMLEN(ncidpl,rid,nlev)
          print *,'nlev guide', nlev 
-         call ncclos(ncidpl,rcod)
+         rcod = nf90_close(ncidpl)
 c   Lecture du premier etat des reanalyses.
          call Gather_Field(ps,ip1jmp1,1,0)
Index: LMDZ4/trunk/libf/dyn3dpar/infotrac.F90
===================================================================
--- LMDZ4/trunk/libf/dyn3dpar/infotrac.F90	(revision 1146)
+++ LMDZ4/trunk/libf/dyn3dpar/infotrac.F90	(revision 1146)
@@ -0,0 +1,317 @@
+MODULE infotrac
+
+! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
+  INTEGER, SAVE :: nqtot
+!!$OMP THREADPRIVATE(nqtot)   
+
+! nbtr : number of tracers not including higher order of moment or water vapor or liquid
+!        number of tracers used in the physics
+  INTEGER, SAVE :: nbtr
+!!$OMP THREADPRIVATE(nbtr)   
+
+! Name variables
+  CHARACTER(len=20), ALLOCATABLE, DIMENSION(:), SAVE :: tname ! tracer short name for restart and diagnostics
+  CHARACTER(len=23), ALLOCATABLE, DIMENSION(:), SAVE :: ttext ! tracer long name for diagnostics
+!!$OMP THREADPRIVATE(tname,ttext)   
+
+! iadv  : index of trasport schema for each tracer
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: iadv
+!!$OMP THREADPRIVATE(iadv)   
+
+! niadv : vector keeping the coorspondance between all tracers(nqtot) treated in the 
+!         dynamic part of the code and the tracers (nbtr+2) used in the physics part of the code. 
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: niadv ! equivalent dyn / physique
+!!$OMP THREADPRIVATE(niadv)   
+
+! Variables for INCA
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: conv_flg
+  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: pbl_flg
+!!$OMP THREADPRIVATE(conv_flg, pbl_flg)   
+
+CONTAINS
+
+  SUBROUTINE infotrac_init
+    IMPLICIT NONE
+!=======================================================================
+!
+!   Auteur:  P. Le Van /L. Fairhead/F.Hourdin
+!   -------
+!   Modif special traceur F.Forget 05/94
+!   Modif M-A Filiberti 02/02 lecture de traceur.def
+!
+!   Objet:
+!   ------
+!   GCM LMD nouvelle grille
+!
+!=======================================================================
+!   ... modification de l'integration de q ( 26/04/94 ) ....
+!-----------------------------------------------------------------------
+! Declarations
+
+    INCLUDE "dimensions.h"
+    INCLUDE "control.h"
+    INCLUDE "iniprint.h"
+
+! Local variables
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: hadv  ! index of horizontal trasport schema
+    INTEGER, ALLOCATABLE, DIMENSION(:) :: vadv  ! index of vertical trasport schema
+
+    CHARACTER(len=8), ALLOCATABLE, DIMENSION(:) :: tnom_0  ! tracer short name
+    CHARACTER(len=8), ALLOCATABLE, DIMENSION(:) :: tracnam ! name from INCA
+    CHARACTER(len=3), DIMENSION(30) :: descrq
+    CHARACTER(len=1), DIMENSION(3)  :: txts
+    CHARACTER(len=2), DIMENSION(9)  :: txtp
+    CHARACTER(len=13)               :: str1,str2
+  
+    INTEGER :: nqtrue  ! number of tracers read from tracer.def, without higer order of moment
+    INTEGER :: iq, new_iq, iiq, jq, ierr
+    INTEGER, EXTERNAL :: lnblnk
+ 
+!-----------------------------------------------------------------------
+! Initialization :
+!
+    txts=(/'x','y','z'/)
+    txtp=(/'x ','y ','z ','xx','xy','xz','yy','yz','zz'/)
+
+    descrq(14)='VLH'
+    descrq(10)='VL1'
+    descrq(11)='VLP'
+    descrq(12)='FH1'
+    descrq(13)='FH2'
+    descrq(16)='PPM'
+    descrq(17)='PPS'
+    descrq(18)='PPP'
+    descrq(20)='SLP'
+    descrq(30)='PRA'
+
+!-----------------------------------------------------------------------
+!
+! 1) Get the true number of tracers + water vapor/liquid
+!    Here true tracers (nqtrue) means declared tracers (only first order)
+!
+!-----------------------------------------------------------------------
+    IF (config_inca == 'none') THEN
+       OPEN(90,file='traceur.def',form='formatted',status='old', iostat=ierr)
+       IF(ierr.EQ.0) THEN
+          WRITE(lunout,*) 'Open traceur.def : ok'
+          READ(90,*) nqtrue
+       ELSE 
+          WRITE(lunout,*) 'Problem in opening traceur.def'
+          WRITE(lunout,*) 'ATTENTION using defaut values'
+          nqtrue=4 ! Defaut value
+       END IF
+       ! Attention! Only for planet_type=='earth'
+       nbtr=nqtrue-2
+    ELSE
+       ! nbtr has been read from INCA by init_cont_lmdz() in gcm.F 
+       nqtrue=nbtr+2
+    END IF
+
+    IF (nqtrue < 2) THEN
+       WRITE(lunout,*) 'nqtrue=',nqtrue, ' is not allowded. 2 tracers is the minimum'
+       CALL abort_gcm('infotrac_init','Not enough tracers',1)
+    END IF
+!
+! Allocate variables depending on nqtrue
+!
+    ALLOCATE(tnom_0(nqtrue), hadv(nqtrue), vadv(nqtrue))
+
+    IF (config_inca /= 'none') THEN
+       ! Varaibles only needed in case of INCA
+       ALLOCATE(conv_flg(nbtr), pbl_flg(nbtr), tracnam(nbtr))
+    END IF
+       
+!-----------------------------------------------------------------------
+! 2)     Choix  des schemas d'advection pour l'eau et les traceurs
+!
+!     iadv = 1    schema  transport type "humidite specifique LMD"
+!     iadv = 2    schema   amont
+!     iadv = 14   schema  Van-leer + humidite specifique 
+!                            Modif F.Codron
+!     iadv = 10   schema  Van-leer (retenu pour l'eau vapeur et liquide)
+!     iadv = 11   schema  Van-Leer pour hadv et version PPM (Monotone) pour vadv
+!     iadv = 12   schema  Frederic Hourdin I
+!     iadv = 13   schema  Frederic Hourdin II
+!     iadv = 16   schema  PPM Monotone(Collela & Woodward 1984)
+!     iadv = 17   schema  PPM Semi Monotone (overshoots autorisés)
+!     iadv = 18   schema  PPM Positif Defini (overshoots undershoots autorisés)
+!     iadv = 20   schema  Slopes
+!     iadv = 30   schema  Prather
+!
+!        Dans le tableau q(ij,l,iq) : iq = 1  pour l'eau vapeur
+!                                     iq = 2  pour l'eau liquide
+!       Et eventuellement             iq = 3,nqtot pour les autres traceurs
+!
+!        iadv(1): choix pour l'eau vap. et  iadv(2) : choix pour l'eau liq.
+!------------------------------------------------------------------------
+!
+!    Get choice of advection schema from file tracer.def or from INCA
+!---------------------------------------------------------------------
+    IF (config_inca == 'none') THEN
+       IF(ierr.EQ.0) THEN
+          ! Continue to read tracer.def
+          DO iq=1,nqtrue
+             READ(90,999) hadv(iq),vadv(iq),tnom_0(iq)
+          END DO
+          CLOSE(90)  
+       ELSE ! Without tracer.def
+          hadv(1) = 14
+          vadv(1) = 14
+          tnom_0(1) = 'H2Ov'
+          hadv(2) = 10
+          vadv(2) = 10
+          tnom_0(2) = 'H2Ol'
+          hadv(3) = 10
+          vadv(3) = 10
+          tnom_0(3) = 'RN'
+          hadv(4) = 10
+          vadv(4) = 10
+          tnom_0(4) = 'PB'
+       END IF
+       
+       WRITE(lunout,*) 'Valeur de traceur.def :'
+       WRITE(lunout,*) 'nombre de traceurs ',nqtrue
+       DO iq=1,nqtrue
+          WRITE(lunout,*) hadv(iq),vadv(iq),tnom_0(iq)
+       END DO
+
+    ELSE  ! config_inca='aero' ou 'chem'
+! le module de chimie fournit les noms des traceurs
+! et les schemas d'advection associes.
+     
+#ifdef INCA
+       CALL init_transport( &
+            hadv, &
+            vadv, &
+            conv_flg, &
+            pbl_flg,  &
+            tracnam)
+#endif
+       tnom_0(1)='H2Ov'
+       tnom_0(2)='H2Ol'
+
+       DO iq =3,nqtrue
+          tnom_0(iq)=tracnam(iq-2)
+       END DO
+
+    END IF ! config_inca
+
+!-----------------------------------------------------------------------
+!
+! 3) Verify if advection schema 20 or 30 choosen
+!    Calculate total number of tracers needed: nqtot
+!    Allocate variables depending on total number of tracers
+!-----------------------------------------------------------------------
+    new_iq=0
+    DO iq=1,nqtrue
+       ! Add tracers for certain advection schema
+       IF (hadv(iq)<20 .AND. vadv(iq)<20 ) THEN
+          new_iq=new_iq+1  ! no tracers added
+       ELSE IF (hadv(iq)==20 .AND. vadv(iq)==20 ) THEN
+          new_iq=new_iq+4  ! 3 tracers added
+       ELSE IF (hadv(iq)==30 .AND. vadv(iq)==30 ) THEN
+          new_iq=new_iq+10 ! 9 tracers added
+       ELSE
+          WRITE(lunout,*) 'This choice of advection schema is not available'
+          CALL abort_gcm('infotrac_init','Bad choice of advection schema - 1',1)
+       END IF
+    END DO
+    
+    IF (new_iq /= nqtrue) THEN
+       ! The choice of advection schema imposes more tracers
+       ! Assigne total number of tracers
+       nqtot = new_iq
+
+       WRITE(lunout,*) 'The choice of advection schema for one or more tracers'
+       WRITE(lunout,*) 'makes it necessary to add tracers'
+       WRITE(lunout,*) nqtrue,' is the number of true tracers'
+       WRITE(lunout,*) nqtot, ' is the total number of tracers needed'
+
+    ELSE
+       ! The true number of tracers is also the total number
+       nqtot = nqtrue
+    END IF
+
+!
+! Allocate variables with total number of tracers, nqtot
+!
+    ALLOCATE(tname(nqtot), ttext(nqtot))
+    ALLOCATE(iadv(nqtot), niadv(nqtot))
+
+!-----------------------------------------------------------------------
+!
+! 4) Determine iadv, long and short name
+!
+!-----------------------------------------------------------------------
+    new_iq=0
+    DO iq=1,nqtrue
+       new_iq=new_iq+1
+
+       ! Verify choice of advection schema
+       IF (hadv(iq)==vadv(iq)) THEN
+          iadv(new_iq)=hadv(iq)
+       ELSE IF (hadv(iq)==10 .AND. vadv(iq)==16) THEN
+          iadv(new_iq)=11
+       ELSE
+          WRITE(lunout,*)'This choice of advection schema is not available'
+          CALL abort_gcm('infotrac_init','Bad choice of advection schema - 2',1)
+       END IF
+      
+       str1=tnom_0(iq)
+       tname(new_iq)= tnom_0(iq)
+       IF (iadv(new_iq)==0) THEN
+          ttext(new_iq)=str1(1:lnblnk(str1))
+       ELSE
+          ttext(new_iq)=str1(1:lnblnk(str1))//descrq(iadv(new_iq))
+       END IF
+
+       ! schemas tenant compte des moments d'ordre superieur
+       str2=ttext(new_iq)
+       IF (iadv(new_iq)==20) THEN
+          DO jq=1,3
+             new_iq=new_iq+1
+             iadv(new_iq)=-20
+             ttext(new_iq)=str2(1:lnblnk(str2))//txts(jq)
+             tname(new_iq)=str1(1:lnblnk(str1))//txts(jq)
+          END DO
+       ELSE IF (iadv(new_iq)==30) THEN
+          DO jq=1,9
+             new_iq=new_iq+1
+             iadv(new_iq)=-30
+             ttext(new_iq)=str2(1:lnblnk(str2))//txtp(jq)
+             tname(new_iq)=str1(1:lnblnk(str1))//txtp(jq)
+          END DO
+       END IF
+    END DO
+
+!
+! Find vector keeping the correspodence between true and total tracers
+!
+    niadv(:)=0
+    iiq=0
+    DO iq=1,nqtot
+       IF(iadv(iq).GE.0) THEN
+          ! True tracer
+          iiq=iiq+1
+          niadv(iiq)=iq
+       ENDIF
+    END DO
+
+
+    WRITE(lunout,*) 'Information stored in dimtrac :'
+    WRITE(lunout,*) 'iadv  niadv tname  ttext :'
+    DO iq=1,nqtot
+       WRITE(lunout,*) iadv(iq),niadv(iq), tname(iq), ttext(iq)
+    END DO
+
+!-----------------------------------------------------------------------
+! Finalize :
+!
+    DEALLOCATE(tnom_0, hadv, vadv)
+    IF (config_inca /= 'none') DEALLOCATE(tracnam)
+
+999 FORMAT (i2,1x,i2,1x,a8)
+
+  END SUBROUTINE infotrac_init
+
+END MODULE infotrac
